* Do-fil til EM4, kapitlene 15 - 21
*************************************
* Alle datafilene kan lastes ned samlet fra bokas nettsted.
* Flere av datafilene kan også åpnes direkte fra Fagbokforlagets server.
* ***********************************
* Kapittel 15
********** 
use "https://nedlasting.fagbokforlaget.no/stata/xy12.dta", clear
list   /* Lister alle variabler for alle enheter */
summ  /* Beskrivende statistikk */
pwcorr x y, sig
* Spredningsdiagram figur 15.2
twoway (scatter y x)(lfit y x), ytitle("Timelønn") xtitle("Utdanning, antall år") ///
  ylabel(0 50 100 150 200 250) legend(off)
***************************************
* Kapittel 16
**********
use "https://nedlasting.fagbokforlaget.no/stata/abu89.dta", clear
* Frekvensfordeling for promot
tabulate promot
* Krysstabell promot etter female, separate tabeller
tabulate promot female
tabulate promot female, column nofreq
tabulate promot female, row nofreq
tabulate promot female, cell nofreq
* Alt i en tabell
tabulate promot female, column row cell 
* Krysstabell med beregning av kjikvadrat og Cramers V
tabulate promot female, cchi2 chi2 V
* Tabell 16.2 på to måter fra tabulate2-dialogboksen
tabulate promot female if private == 0, cchi2 chi2 V
tabulate promot female if private == 1, cchi2 chi2 V
* eller
 by private, sort : tabulate promot female, cchi2 chi2 V
 * Observerte og forvcentede frekvener, bidrag til kjikvaDRAT
 tabulate promot female, cchi2 cell chi2 expected
 *************************************
 * Kapittel 17
 **********
 ** Faktoranalyse 
 * Merk at filen må lastes ned fra bokas nettsted og lagres lokalt.
 * Bytt banen i use-kommandoen med bane til lokal lagring.
use "C:\Users\kristenr\Dropbox\EM4\Kapittel 17 Sammensatte mål\ESS8NO_tillit.dta"
summ trstprl trstlgl trstplc trstplt trstprt
* Kloner de 5 indikatorene til variabler mer forståelige navn
clonevar storting = trstprl
clonevar rettsvesen = trstlgl
clonevar politi = trstplc
clonevar politikere = trstplt
clonevar partier = trstprt
summ storting rettsvesen politi politikere partier
factor storting rettsvesen politi politikere partier, pcf
screeplot
estat kmo
**** Tofaktor-løsning
factor storting rettsvesen politi politikere partier, mineigen(.8)pcf
rotate
loadingplot
rotate, promax
* Reliabilitetsanalyse
* Først se på korrelasjonsmatrisen
corr politikere partier storting rettsvesen politi
** Cronbachs alfa
alpha politikere partier storting rettsvesen politi, casewise item std
egen miss5 = rowmiss(politikere partier storting rettsvesen politi)
egen tillit = rowmean(politikere partier storting rettsvesen politi) if miss5==0
****************************************
* Kapittel 18
**********
** Do-fil til kapittel 18
** t-testen for to uavhengige utvalg
use "https://nedlasting.fagbokforlaget.no/stata/abu89.dta", clear
ttest time89, by(female) unequal  /* T-test, sigma ulik */
* T-testen for parede utvalg
use "https://nedlasting.fagbokforlaget.no/stata/abu89_93.dta", clear
ttest time93 == time89  /* t-test for parede utvalg */
use "https://nedlasting.fagbokforlaget.no/stata/abu89.dta", clear
** enveis variansanalyse
oneway time89 klasse89, tabulate bonferroni
* effektstørrelse
estat esize
estat esize, omega
***************************************
* Kapittel 19
**********
* Regresjonsanalyse av timelønn, abu89.dta
use "https://nedlasting.fagbokforlaget.no/stata/abu89.dta", clear
* Tabell 19.3
summarize time89 ed age female
* Figur 19.9
histogram time89, percent normal
***************
* Utskift for  Modell 1, s 419
regress time89 ed 
***********
* Tabell 19.4 Modell 1&2 i en kommando
* Blokkvis regresjon med nestreg
****
nestreg: regress time89 (ed) (age female), beta
*
** Er sammenhengen mellom timelønn og alder lineær?
lowess time89 age
* twoway (scatter time89 age)(lfit time89 age), ytitle("Timelønn")
quietly: regress time89 age
predict pred_lin
lowess time89 age, gen(pred_low) 
** Begge linjene i samme scatter plot
twoway (scatter time89 age)(lfit time89 age) ///
   (line pred_low age, sort), ytitle("Timelønn")
* 2.gradsledd av alder
generate age2 = age^2
label variable age2 "Alder kvadrert"
regress time89 age age2
predict pred_kvad  /* Predikerte verdier lagres */
**********************
* Figur 19.10  Tre prediksjonslinjer i samme diagram
********
twoway (line pred_lin age)(line pred_kvad age, sort) ///
   (line pred_low age, sort), ytitle("Timelønn") ///
   xlabel(20 30 40 50 60 70 80)ylabel(0 40 80 120 160 200)
***************
* To måter å sette opp samme modell
regress time89 ed c.age c.age#c.age female           
regress time89 ed c.age##c.age female
*
* Forenklet modell med samspill utdanning*kjønn
regress time89 c.ed##c.female, beta    /* Samlet analyse */
** For kvinner
regress time89 ed if female ==1, beta    /* Kvinner */
regress time89 ed if female ==0, beta    /* Menn */
*
* Modell 4 med samspill
regress time89 c.ed##female c.age##c.age, beta
* Samspillet Figur 19.14
margins female, at(ed=(0(1)11))
marginsplot, noci
marginsplot, recast(line) recastci(rarea) ylabel(0 40 80 120 160 200) ///
  xlabel(0 2 4 6 8 10)ytitle(Predikert timelønn)
** Varierende alderseffekt
regress time89 c.ed##female c.age##c.age, beta
margins, at(age=70) dydx(age)
margins, at(age=(20(10)70)) dydx(age)
*** Kurven for alder i figur 19.15
margins, at(age=(16(1)74))
marginsplot, ylabel(0 40 80 120 160 200)xlabel(20 30 40 50 60 70)  ///
  ytitle(Predikert timelønn)
marginsplot, noci ylabel(0 40 80 120 160 200)xlabel(20 30 40 50 60 70) ///
  ytitle(Predikert timelønn)
marginsplot, recast(line) recastci(rarea) ylabel(0 40 80 120 160 200) ///
  xlabel(20 30 40 50 60 70)ytitle(Predikert timelønn)
** Undersøke forutsetningene om residualene for modell 4
regress time89 c.age##c.age c.ed##female
*** Residualer - diagnoseplott
predict res, resid
predict zres, rstandard
histogram zres, frequency normal  /* Figur 19.11 */
pnorm res     /* Normal probability plot figur 19.12 */
rvfplot, msize(small)   /* Figur 19.13 */
** Regresjon med logaritmisk transformasjon av timelønn
gen ltime89 = ln(time89)   /* naturlig log av time89 */
histogram ltime89, percent normal
* Estimere modellen med ltime89 
regress ltime89 c.age##c.age c.ed##female, beta
*  uten samspill
regress ltime89 c.age##c.age ed female, beta
*****************
* Regresjon med dummyvariabler
**
*  lage missing indikator
egen miss5 = rowmiss (time89 klasse89)
tabu miss5
regress time89 ed age female b5.klasse89
contrast klasse89   /* Wald test for klasse89 */
regress ltime89 c.age##c.age c.ed##female if miss5 == 0
estimates store m4a
regress ltime89 c.age##c.age c.ed##female b5.klasse89 if miss5 == 0
estimates store m5a
lrtest m5a m4a
contrast klasse89
*
regress ltime89 ed c.age##c.age female b5.klasse89 if miss5 == 0
** Gir klasse89 en statistisk signifikant forbedring av modellen?
regress time89 ed c.age##c.age female female#c.ed  if miss5 == 0
regress time89 ed c.age##c.age female female#c.ed b5.klasse89 if miss5 == 0
contrast klasse89    /* gir samme resultat som F-test i EM3 s 431 fra SPSS */
*********************************
* Kapittel 20
**********
* Tabell 20.2 Logistiske regresjonsodeller
* Modell 1
logistic promot female, coef
logistic   /* rapporterer OR */
* Modell 2
logistic promot female ed fexp private, coef 
logistic   /* rapporterer OR */
* predikerte sannsynligheter
margins, at (female=(0,1))
* private
margins, at (private=(0,1))
* Figur 20.3
margins, at(ed=(0/11)) plot(plotopts(msymbol(none)) recastci(rarea) ///
  xtitle(Utdanning i år) ytitle(P(Forfremmet)) yscale(range(0.0 1.0)) ///
  ylabel(0.0 0.2 0.4 0.6 0.8 1.0)xlabel (0 2 4 6 8 10))
*
* Modell 3
logistic promot female ed fexp private c.ed#female
logistic
* Modell 4
logistic promot female ed fexp c.fexp#c.fexp private, coef
logistic
margins, at(fexp= (0.0(0.2)5.0)) plot(plotopts(msymbol(none)) recastci(rarea) ///
 xtitle(Ansiennitet i 10-år) yscale(range(0.00 0.70)) ylabel(0.0 0.1 0.2 0.3 0.4 0.5 0.6))
* Uten konf intervall
margins, at(fexp= (0.0(0.2)5.0)) plot(plotopts(msymbol(none)) noci ///
 xtitle(Ansiennitet i 10-år) yscale(range(0.00 0.70)) ylabel(0.0 0.1 0.2 0.3 0.4 0.5 0.6))
*
** Modell 4 i OLS
regress promot female ed fexp c.fexp#c.fexp private
margins, at(fexp= (0.0(0.2)5.0)) plot(plotopts(msymbol(none)) noci ///
 xtitle(Ansiennitet i 10-år) yscale(range(0.00 0.70)) ylabel(0.0 0.1 0.2 0.3 0.4 0.5 0.6))
** lr-test
quietly: logistic promot female 
estimates store m1
quietly: logistic promot female ed fexp private
estimates store m2
lrtest m1 m2
***************************************
* Kapittel 21
**********
use "C:\Users\kristenr\Dropbox\Statabok\Data\wage89.dta", clear
* Eksempel 1 flermnivåanalyse av timelønn
*** Transformere wage og size
gen lnwage = ln(wage)
gen lnsize = ln(size)
summ wage size lnwage lnsize
*
* Trinn 1 Nullmodellen,  utskrift s. 479)
mixed lnwage || firmno:
* Trinn 2 er uført i Kapittelet om regresjonsanalyse
mixed lnwage ed c.age##c.age female|| firmno:
estimates store kons
** Trinn 3 Varierer effekten av utdanning mellom virksomhetene?
* (siste del i utskrift s. 480)
mixed lnwage edyears c.age##c.age female || firmno: edyears, cov(un)
estimates store koeff
lrtest kons koeff
* Trinn 4 med lnsize og kryssnivåsamspill
mixed lnwage edyears c.age##c.age female lnsize c.edyears#c.lnsize || firmno: edyears, cov(un)
***********************************
* Tabell 21.2 Estimeringsteknikkene sammenlignet
********
** Merk at overskriften på siste kolonne i tabellen s. 484-485 er feil "copeinc" skal være "edyears".
* Vanlig regresjon - OLS
regress lnwage edyears c.age##c.age female lnsize
regress lnwage edyears c.age##c.age female lnsize, cluster(firmno) 
regress lnwage edyears c.age##c.age female lnsize c.edyears#c.lnsize, cluster(firmno) 
* Fixed effects modellen
xtset firmno   /* Definerer gruppevariabel for xtreg */
xtreg lnwage edyears c.age##c.age female, fe 
* Flernivåmodellene
* Random intercept
mixed lnwage edyears c.age##c.age female lnsize || firmno:
* Random coeff edyears
mixed lnwage edyears c.age##c.age female lnsize c.edyears#c.lnsize || firmno: edyears
********************************
* Eksempel 2 Lykke i Europa
*********
* Merk at filen må lates ned fra bokas nettsted og lagres lokalt.
 * Bytt banen i use-kommandoen med bane til lokal lagring.
use "C:\Users\kristenr\Dropbox\EM4\Kapittel 21 Flernivåanalyse\Lykke.dta", clear
* Tabell 21.3 Beskrivende statistikk
summ happy alder kvinne samboer utdann copeinc hdi2012 kulik2012
* Trinn 1 nullmodellen  
mixed happy || cntry:
* Trinn 2 Utvikle modellen for nivå-1   (utskrift faste koeffisienter s. 488 )
mixed happy c.alder##c.alder kvinne samboer utdann copeinc || cntry:
estimates store konstant
* Trinn 3 Utvikle den stokastiske delen av modellen  (utskrift stokastisk del s. 488)
mixed happy c.alder##c.alder kvinne samboer utdann copeinc || cntry: copeinc, cov(un)
estimates store koeff
lrtest konstant koeff
Trinn 4 legge til nivå-2 variabler
mixed happy c.alder##c.alder kvinne samboer utdann copeinc hdi2012 c.copeinc#c.hdi2012 ///
    || cntry: copeinc, cov(un)
* samspillet er ikke statistisk signifikant og kuttes
mixed happy c.alder##c.alder kvinne samboer utdann copeinc hdi2012 ///
    || cntry: copeinc, cov(un)
*
* Tabell 21.4 Ulike modeller for lykke
* ett nivå-modeller OLS
regress happy c.alder##c.alder kvinne samboer utdann copeinc hdi2012  /* vanlig regresjon */
regress happy c.alder##c.alder kvinne samboer utdann copeinc hdi2012, cluster(cntry)
regress happy c.alder##c.alder kvinne samboer utdann c.copeinc##c.hdi2012, cluster(cntry)
* Fixed effects model
xtset country   /* Definerer gruppevariabel for xtreg */
xtreg happy c.alder##c.alder kvinne samboer utdann copeinc, fe 
*** flernivåmodellene
mixed happy c.alder##c.alder kvinne samboer utdann copeinc hdi2012 || cntry:
mixed happy c.alder##c.alder kvinne samboer utdann c.copein##c.hdi2012 || cntry: copeinc, cov(un)
**endelig modell
mixed happy c.alder##c.alder kvinne samboer utdann copeinc hdi2012 || cntry: copeinc, cov(un)
margins, at(hdi2012=(0.75(0.05)0.95))
marginsplot, noci recast(line), ylabel(1(2)10)
**** SLUTT ******



